;*******************************************************************************
;*                            Infrs kapcsol ad                              *
;*******************************************************************************	

	LIST	P=PIC10F322	; lista megad??sa
	RADIX	hex		; alap?rtelmezet sz??mrendszer megad??sa
	#include "p10F322.inc"


 __CONFIG _FOSC_INTOSC & _BOREN_OFF & _WDTE_OFF & _MCLRE_OFF & _LVP_OFF & _LPBOR_OFF

 
    CBLOCK  0x40
    ADATBYTE
    CIKLUS
    CIKLUS2
    CIKLUS3
    ENDC
    
    
WAIT	MACRO	MENNYIT
    MOVLW   MENNYIT
    MOVWF   CIKLUS2          ;A ksleltets makrja a T2 id?reln alapul.
    BTFSS   PIR1,1           ;Ez nem csak knyelmi megolds, hanem az ads
    GOTO    $-1              ;pontoss s egyszer?v ttele miatt van.
    BCF	    PIR1,1
    DECFSZ  CIKLUS2
    GOTO    $-4
    ENDM
    
   
    org	    0x0000
    nop
    
INICIALIZALAS
    CLRF    LATA
    CLRF    ANSELA
    CLRF    ADCON
    MOVLW   B'00001000'       ;RA3 bemenet. minden egyb kimenetnek lltva
    MOVWF   TRISA
    CLRF    OPTION_REG        ;Oprion reg trlve, hogy engedlyezze a WPUA-t
    MOVLW   B'00001000'       ;RA3 bels? felhz ellenllsa bekapcsolva
    MOVWF   WPUA
    MOVLW   B'01010000'       ;Oscilltor 4MHz-re lltva.
    MOVWF   OSCCON
    MOVLW   B'00000100'       ;T2 bekapcsolsa. El? s utoszt nincs.
    MOVWF   T2CON             ;T2 id?zt? (PWM peridus ideje) 25-re lltva,
    MOVLW   .25               ;(ami valjban 26) gy a PWM frekvencia kb  
    MOVWF   PR2               ;38,5 KHz.
    MOVLW   B'10000000'       ;PWM2 kivlasztsa.
    MOVWF   PWM2CON
    CLRF    PWM2DCL
    MOVLW   .13               ;Kitlts belltsa
    MOVWF   PWM2DCH
    MOVLW   .20
    MOVWF   CIKLUS3
    ;---------------
MAIN
    WAIT    .250          ;Adatklds el?tti s kldsek kztti kb. 13msec-es
    WAIT    .250          ;vrakozs
    MOVLW   .112
    MOVWF   ADATBYTE
    CALL    KULDES        ;Els? adat kldse
    WAIT    .10           ;Az adatok kldse kztt van kb. 250 usec vrakozs
    MOVLW   .25
    MOVWF   ADATBYTE
    CALL    KULDES        ;Msodik adat kldse
    WAIT    .10
    MOVLW   .52
    MOVWF   ADATBYTE
    CALL    KULDES        ;Harmadik adat kldse
    WAIT    .10
    MOVLW   .250
    MOVWF   ADATBYTE
    CALL    KULDES        ;Negyedik adat kldse
    DECFSZ  CIKLUS3       ;Adatcsomag visszaszmll. 20 klds utn befejezi
    GOTO    MAIN          ;az adst.
    CLRF    PWM2CON
    CLRF    LATA
    GOTO    $-0    
KULDES
    MOVLW   .8            ;Ciklusszmllt feltltm 8-al.
    MOVWF   CIKLUS    
KULDES1  
    WAIT    .10           ;Az adatbyte elkldse egyszer?stve van. A WAIT    
    BSF	    PWM2CON,6     ;id?zt? a PWM peridusait szmolja. Bit klds el?tt 
    WAIT    .10           ;10 peridust kivr, majd engedlyezi PWM kimenett.
    BTFSS   ADATBYTE,7    ;jabb 10 peridus utn megnzi, hogy az adatbyte 7-es 
    BCF	    PWM2CON,6     ;bitje mi. Ha alacsony, lekapcsolja a PWM kimenetet.
    WAIT    .15           ;Ezutn jabb 15 peridust kivr, majd fggetlenl a 
    BCF	    PWM2CON,6     ;PWM kimenet llapottl, lekapcsolja azt.
    RLF     ADATBYTE      ;Ezutn eggyel balra tolja az adatbyte bitjeit.
    DECFSZ  CIKLUS        ;Vgl levon egyet a ciklusszmll rtkb?l.
    GOTO    KULDES1       ;Ha ciklusszmll mg nem 0, akkor ciklus elejre, ha
    RETURN                ;0, akkor a meghvsi pontra ugrik.  
;-------------------------------------------------------------------------------
    END
    